# Node/Typescript Starter Kit

This is a template repository for a Node/Typescript-based BFF or micro-service.

## Getting started

1. Click the 'Use this template' button above or [this link](./generate) to generate a new repository 
from this template.
2. Clone the newly created template to your computer
3. Update the project name in the `project.json` file and update the README with the following steps,
run from the root of your project directory:
```bash
mv README.md STARTER-KIT.md
echo "# {project name}" > README.md
```
4. Add and commit the changes to your repo.

## Features

The starter kit provides the following features:

- REST services using `typescript-rest` decorators
- Swagger documentation using `typescript-rest-swagger`
- Dependency injection using `typescript-ioc` decorators
- Logging using `bunyan`
- TDD environment with `jest`
- Pact testing
- DevOps pipeline
